apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "hr-ms.fullname" . }}
  labels:
    {{- include "hr-ms.labels" . | nindent 4 }}
spec:
  replicas: {{ .Values.replicaCount }}
  selector:
    matchLabels:
      {{- include "hr-ms.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      labels:
        {{- include "hr-ms.selectorLabels" . | nindent 8 }}
    spec:
    {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
    {{- end }}
      serviceAccountName: {{ include "hr-ms.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.image.registry }}/{{ .Values.image.repository }}:{{ .Values.image.imageTag }}"
          # volumeMounts:
          # - name: secrets-store-demo
          #   mountPath: "/mnt/secrets-store"
          #   readOnly: true
          # volumes:
          # - name: secrets-store-demo
          #   csi:
          #    driver: secrets-store.csi.k8s.io
          #    readOnly: true
          #    volumeAttributes:
          #     secretProviderClass: "demo-certif-secret-provider-class"
          #    nodePublishSecretRef:              
          #     name: secrets-store-creds-demo
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          env:
          - name: "spring.cloud.config.uri"
            value: {{ .Values.springCloudConfigUri }}
          - name: "spring.profiles.active"
            value: {{ .Values.springProfilesActive }}
          - name: "datasource.password"
            value: {{ .Values.postgresqlPassword }}
          # - name: "azure.keyvault.uri"
          #   value: {{ .Values.keyvaultUri }}
          # - name: "azure.keyvault.enabled"
          #   value: 'true'
          # - name: "azure.keyvault.client-id"
          #   valueFrom:
          #     secretKeyRef:
          #       name: aks-kv-integration
          #       key: username
          # - name: "azure.keyvault.client-key"
          #   valueFrom:
          #     secretKeyRef:
          #       name: aks-kv-integration
          #       key: password  
          # - name: "elasticsearch.host"
          #   value: {{ .Values.elasticsearchHost }}
          # - name: "elasticsearch.port"
          #   value: {{ .Values.elasticsearchPort | quote  }}
          ports:
            - name: http
              containerPort: {{ .Values.service.port }}
              protocol: TCP
          livenessProbe:
            httpGet:
              path: /actuator/info
              port: http
            initialDelaySeconds: 60
            periodSeconds: 60
          readinessProbe:
            httpGet:
              path: /actuator/health
              port: http
            initialDelaySeconds: 60
            periodSeconds: 20
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
    {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
    {{- end }}
    {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
    {{- end }}
